#pragma comment(linker, "/stack:64000000")

#include <cassert>
#include <cstring>
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <vector>

using namespace std;

const int maxn = 2000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

const int AC = 0;
const int WA = 1;
const int PE = 2;
const int UE = 3;

int w, h;
int k;
string s[maxn];
int vis[maxn][maxn];

void dfs(int i, int j)
{
	vis[i][j] = 1;
	k++;
	for (int d = 0; d < 4; d++) {
		int i1 = i + dx[d];
		int j1 = j + dy[d];
		if (0 <= i1 && i1 < h && 0 <= j1 && j1 <= w) {
			if (s[i1][j1] == '#' && !vis[i1][j1])
				dfs(i1, j1);
		}
	}
}

int check(ifstream &f, string &comment, int &score)
{
    int x, y;

    f >> x >> y;
    if (!f) {
        comment = "couldn't read answer";
        return PE;
    }
    x--; y--;
    if (x < 0 || x >= w || y < 0 || y >= h) {
        comment = "out of the field";
        return PE;
    }
    
    if (s[y][x] != '.') {
        comment = "place is taken";
        return WA;
    }

    memset(vis, 0, sizeof(vis));
    k = 0;
    dfs(y, x);
    score = k;
    return AC;
}

int main(int argc, char* argv[])
{
    ifstream f_in(argv[1]);
    ifstream f_out(argv[2]);
    ifstream f_ans(argv[3]);

    f_in >> w >> h;
    assert(2 <= w && w <= 2000);
    assert(2 <= h && h <= 2000);
    
	getline(f_in, s[0]);
	for (int i = 0; i < h; i++) {
		getline(f_in, s[i]);
	}
	
    string jury_comment, cont_comment;
    int jury_score, cont_score;
    int jury_res = check(f_ans, jury_comment, jury_score);
    int cont_res = check(f_out, cont_comment, cont_score);

    if (jury_res != AC) {
        cout << "jury fail: " << jury_comment << endl;
        return UE;
    }

    if (cont_res != AC) {
        cout << cont_comment << endl;
        return cont_res;
    }

    if (jury_score > cont_score) {
        cout << "contestant worse" << endl;
        return WA;
    }

    if (jury_score < cont_score) {
        cout << "jury better" << endl;
        return UE;
    }

    cout << "ok" << endl;
    return AC;
}

