#include <algorithm>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <vector>

using namespace std;

const int tests_start = 9;

ofstream out;
int current_test;

void new_test()
{
    if (current_test >= tests_start) out.close();
    current_test++;
    ostringstream ss;
    ss << setfill('0') << setw(2) << current_test;
    out.open(ss.str().c_str());
    cout << ss.str() << endl;
}

void gen_random_test(int n, int m, double p)
{
    new_test();
    out << n << " " << m << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
    	    int k = rand() % 10000;
    	    char ch = (k < p*10000) ? '#' : '.';
    	    out << ch;
        }
        out << endl;
    }
}

int main()
{
    current_test = tests_start - 1;
    srand(6274512);
	gen_random_test(10, 10, 0.25);
	gen_random_test(10, 10, 0.5);
	gen_random_test(10, 10, 0.75);
	gen_random_test(100, 100, 0.5);
	gen_random_test(1000, 1000, 0.5);
	gen_random_test(2000, 2000, 0.25);
	gen_random_test(2000, 2000, 0.5);
	gen_random_test(2000, 2000, 0.75);
	return 0;
}

