#pragma comment(linker, "/stack:64000000")

#include <cassert>
#include <cstdio>
#include <iostream>
#include <string>
#include <map>

using namespace std;

const int maxn = 2000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

int w, h;
int k;
string s[maxn];
int vis[maxn][maxn];
int num[maxn*maxn];
int vis1[maxn*maxn];
int seq[4], seq_len;

void dfs(int i, int j)
{
	vis[i][j] = k;
	num[k]++;
	for (int d = 0; d < 4; d++) {
		int i1 = i + dx[d];
		int j1 = j + dy[d];
		if (0 <= i1 && i1 < h && 0 <= j1 && j1 < w) {
			if (s[i1][j1] == '#' && !vis[i1][j1])
				dfs(i1, j1);
		}
	}
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	int i, j;

	cin >> w >> h;
	assert(2 <= w && w <= maxn);
	assert(2 <= h && h <= maxn);
	getline(cin, s[0]);
	for (i = 0; i < h; i++) {
		getline(cin, s[i]);
	}
	
	for (i = 0; i < h; i++)
		for (j = 0; j < w; j++) {
			if (s[i][j] == '#' && !vis[i][j]) {
				k++;
				dfs(i, j);
			}
		}
		
	/*cout << k << endl;
	for (i = 1; i <= k; i++)
		cout << num[i] << " ";
	cout << endl;*/
		
	int best_x = 0, best_y = 0;
	int best = 0;
	for (i = 0; i < h; i++) {
		for (j = 0; j < w; j++) {
			if (s[i][j] == '#') continue;
			int cur = 0;
			seq_len = 0;
			for (int d = 0; d < 4; d++) {
				int i1 = i + dx[d];
				int j1 = j + dy[d];
				if (0 <= i1 && i1 < h && 0 <= j1 && j1 < w) {
					if (s[i1][j1] == '#') {
					    int comp = vis[i1][j1];
					    if (!vis1[comp]) {
					        vis1[comp] = 1;
					        cur += num[comp];
					        seq[seq_len] = comp;
					        seq_len++;
					    }
				    }
				}
			}
			
			for (int sc = 0; sc < seq_len; sc++)
			    vis1[seq[sc]] = 0;
			
			if (cur > best) {
				best = cur;
				best_x = j;
				best_y = i;
			}
			
			/*cout << i << " " << j << " " << cur << ": ";
			for (map<int, int>::iterator it = m.begin(); it != m.end(); it++)
				cout << it->second << " ";
			cout << endl;	*/
		}
		//cout << endl;
	}
	
	cout << best_x + 1 << " " << best_y + 1 << endl;
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}

